class Appfront::Command::Auth < Appfront::Command::Base
  require 'netrc'

  def self.login
    puts "Enter your Appfront credentials."

    print "email: "
    email = ask

    print "password: "

    echo_off
    pass = ask_for_password
    echo_on

    api = Appfront::API.new(email: email, password: pass)
    key = api.login

    netrc.delete 'jarvis.appfront.io'

    netrc['jarvis.appfront.io'] = email, key
    netrc.save

    true
  end

  def self.signup
    puts "Welcome to Appfront \n"
    puts "Insert your credentials to signup"

    print "email: "
    email = ask

    print "password: "

    echo_off
    pass = ask_for_password
    echo_on

    api = Appfront::API.new(email: email, password: pass)
    key = api.signup
    unless key
      exit 1
      puts "There was a problem during registration, please try it later. \n"
    end
    netrc.delete 'jarvis.appfront.io'

    netrc['jarvis.appfront.io'] = email, key
    netrc.save
    puts "Registration complete, we've already logged you in... \n"
    puts "Find out more by typing: appfront help\n"
    true
  end

  def self.logout
    netrc.delete 'jarvis.appfront.io'
    netrc.save

    true
  end

  def self.authenticate!
    return true if authenticated?
    login
  end

  def self.credentials
    netrc['jarvis.appfront.io']
  end

  private
  def self.netrc
    @netrc ||= Netrc.read netrc_path
  end

  def self.netrc_path
    default   = Netrc.default_path
    encrypted = default + ".gpg"

    File.exists?(encrypted) ? encrypted : default
  end

  def self.ask_for_password
    echo_off
    password = ask
    puts
    echo_on

    password
  end

  def self.authenticated?
    netrc['jarvis.appfront.io'] ? true : false
  end
end
