class Appfront::Command::Config < Appfront::Command::Base
  def self.set(vars, opts)
    unless vars.size > 0 and vars.all? { |a| a.include?('=') }
      puts "Usage: appfront config:set KEY1=VALUE1 [KEY2=VALUE2 ...]\nMust specify KEY and VALUE to set."
      exit 1
    end

    find_deploy! opts

    spinner "Setting ENV vars..." do
      vars.each do |var|
        k, v = var.split '=', 2
        api.post "/flow/#{@deploy}/envs/#{k}", value: v
      end
    end
    puts 
    puts
    Appfront::Command::Config::ls opts
    puts
    puts 'Please use ps:restart command to restart your app when you\'re ready.'
  end

  def self.unset(vars, opts)
    if vars.empty?
      puts "Usage: appfront config:unset KEY1 [KEY2 ...]\nMust specify KEY to unset."
      exit 1
    end

    find_deploy! opts

    spinner "Unsetting ENV vars..." do
      vars.each do |var|
        k, v = var.split '=', 2
        api.delete "/flow/#{@deploy}/envs/#{k}"
      end
    end  
    puts 
    puts 
    Appfront::Command::Config::ls opts
    puts
    puts 'Please use ps:restart command to restart your app when you\'re ready.'
  end

  def self.ls(opts)
    find_deploy! opts

    puts "=== #{@deploy} Config Vars"

    vars = api.get("/flow/#{@deploy}/envs")

    vars.each do |k| 
      k.each_pair {|k,v| puts "#{k}:\t #{v}"}
    end
  end

end
