class Appfront::Command::Domains < Appfront::Command::Base

  def self.rm(args, opts)
    exit 1 unless args[0]
    find_deploy! opts
    spinner "Removing domain..." do
      api.delete "/domain/#{args[0]}/#{@deploy}"
    end
    puts "\n"
  end

  def self.add(args, opts)
    exit 1 unless args[0]
    puts args[0]
    find_deploy! opts
    spinner "Adding domain..." do
      api.post "/domain/#{args[0]}/#{@deploy}"
    end
    puts "\n"
  end

  def self.info(opts)
    find_domain! opts

    h = api.get "/domain/#{@deploy}"
    
    puts "=== Domain: #{h['name']}"
    puts
    puts "\t Deploy uuid: #{h['uuid']}"
    puts "\t Status: #{h['status']} "
    puts "\t Running deploys: #{h['deploys']}"
    puts 
    puts "=== Cluster: #{h['cluster_name']} ---> #{h['cluster']}"
    
    puts "\n"    

  end

  def self.ls
    domains = api.get "/domains"
    unless domains.count == 0
      puts '=== Domains List'
      domains.each do |domain| 
        chars = 30 - domain['name'].chars.count
        output = "name: #{domain['name']}"
        for i in 0..chars 
          output = output + ' '
        end
        output = output + "---> Deploy uuid: #{domain['flow_uuid']}   name: #{domain['flow_name']}"
        puts output
      end
    else
      puts '=== You have no domains.'
    end
    puts "\n"
  end
end
