class Appfront::Command::Help < Appfront::Command::Base
  def self.root_help
    puts <<-HELP
Usage: appfront COMMAND [-d DEPLOY] [command-specific-options]

Primary help topics, type "appfront help TOPIC" for more details:

  deploys      #  manage deploys
  clusters   #  manage clusters
  providers  #  manager connection with Amazon or DigitalOcean

Additional topics:

  help         #  list commands and display help
  version      #  display version
    HELP
  end

  def self.deploys
    puts <<-HELP
Deploys commands:

  deploys:destroy -d [deploy uuid]                     # permanently destroy an deploy
  deploys:info    -d [deploy uuid]                     # show detailed deploy information
  deploys:list                                         # show deploys list
  deploys:attach  -d [deploy uuid]  [cluster uuid]     # attach cluster to a deploy
    HELP
  end

  def self.clusters
    puts <<-HELP
Clusters commands:

  clusters:create -p [provider] [NAME] [type] [region]    # create a new cluster
  clusters:rm     -p [provider] [cluster uuid]            # permanently destroy a cluster
  clusters:info      [cluster uuid|name]                       # show detailed cluster information
  clusters:list      [cluster uuid|name]                       # show clusters list
    HELP
  end

  def self.providers
    puts <<-HELP
Providers commands:

  providers:connect -p [amazon|digitalocean] -a access_key  -s secret_key       # connect to the choosen provider
  providers:disconnect                                                          # disconnect from provider
    HELP
  end


  def self.ps
    puts <<-HELP
PS commands:

  ps:resize  web=TIER                     #  resize dot to the given tier
  ps:scale   web=N [mode=scaling|manual]  #  scale dots by the given amount
  ps:stop                                 #  stop all dots
  ps:reload                               #  restart all dots
    HELP
  end

  def self.method_missing(m, *args, &block)
    unless self.respond_to? m
      puts "Invalid command: #{m}"
      exit 1
    end
  end
end
