class Appfront::Command::Providers < Appfront::Command::Base

  def self.list
    providers = api.get "/providers"
    unless providers.count == 0
      puts '=== Providers Connection Status:'
      providers.each do |p| 
        puts "\t#{p['tier'].capitalize} ---> Connected"
      end
    else
      puts '=== No Providers connected with this account'
    end
  end

  def self.disconnect(args, opts)
    provider = opts[:provider]
    exit 1 unless provider == 'amazon' or provider == 'digitalocean'

    spinner "Disconnecting #{provider.capitalize}... " do
      api.delete "/provider/#{provider}"
    end
    puts "\n"
  end

  def self.connect(opts)
    exit 1 unless opts[:provider] and opts[:access] and opts[:secret]
    provider = opts[:provider]
    spinner "Connecting your account with #{provider.capitalize}... " do
      api.post "/provider/#{provider}", access_key: opts[:access], secret_key: opts[:secret]
    end
    puts "\n"
  end

end
